2008-11-21  Andreia Gaita  <shana@jitted.com>

	* Metafile.cs: Save the underlying stream when creating from a
	clone under win32 (fixes #438886)

2008-10-12  Sebastien Pouliot  <sebastien@ximian.com>

	* ColorPalette.cs, ImageFormat.cs: Remove unneeded field 
	initialization to their default values.
	[Found using Gendarme AvoidUnneededFieldInitializationRule]

2008-08-06  Sebastien Pouliot  <sebastien@ximian.com>

	* FrameDimension.cs: Fix double-cast in Equals (found using Gendarme).
	Then fixed a lot of other things while creating unit tests for it.

2008-07-14  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageAttributes.cs: Fix GetAdjustedPalette using new (and correct)
	signature.

2008-06-23  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageAttributes.cs: Call CheckStatus in GetAdjustedPalette before
	trying to set the palette (since the values could be bad).
	[Partial fix for #402172]

2008-05-14  Sebastien Pouliot  <sebastien@ximian.com>

	* EncoderParameters.cs: Don't downcast an IntPtr to an Int32.
	[Found using Gendarme]

2007-12-13 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodec.jvm.cs: fixed bitmap resolution

2007-11-05  Sebastien Pouliot  <sebastien@ximian.com> 

	* Metafile.cs: Stream position is not moved for metafiles.

2007-05-30  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageAttributes.cs: Remove TODO for ColorMatrixFlags and Gray 
	ColorMatrix support methods. Add TODO on some stuff not supported by
	libgdiplus (so MoMA reports gets more accurate). Fix coding style.

2007-05-09 Igor Zelmanovich <igorz@mainsoft.com>

	* EncoderParameter.jvm.cs: removed destructor, 
	Dispose doesn't throw exception.

2007-04-26  Sebastien Pouliot  <sebastien@ximian.com> 

	* Metafile.cs: Reduce size by reusing more complex ctors. Add Linux
	support to metafile recoding with the new delegate-based functions.

2007-04-26  Sebastien Pouliot  <sebastien@ximian.com>

	* Metafile.cs: Complete all ctors (except for stream-based one outside
	Windows) with calls into GDI+.

2007-03-28  Sebastien Pouliot  <sebastien@ximian.com>  

	* MetaHeader.cs: Make workaround (#81254) permanent and return correct
	values on big endian architectures.

2007-03-28  Sebastien Pouliot  <sebastien@ximian.com> 

	* MetaHeader.cs: Workaround bug #81254 where the SPARC architecture 
	can't use the misaligned integer in the structure (with Pack=2).

2007-03-14  Sebastien Pouliot  <sebastien@ximian.com> 

	* MetafileHeader.cs: WmfHeader is available on non-placeable WMF too.

2007-03-09  Sebastien Pouliot  <sebastien@ximian.com> 

	* MetafileHeader.cs: WmfHeader throws if the metafile isn't a WMF (e.g. 
	EMF, EMF+ or EMF dual).

2007-03-09  Sebastien Pouliot  <sebastien@ximian.com>

	* MetafileHeader.cs: Fix offset to match correct C definition.

2007-02-21  Sebastien Pouliot  <sebastien@ximian.com>

	* Metafile.cs: Implement a few cases required to playback metafiles.
	* MetafileHeader.cs: Implemented.
	* MetaHeader.cs: Implemented.
	* WmfPlaceableFileHeader.cs: Adjust packing.

2007-01-12  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageAttribute.cs: Reuse code in SetColorMatrix overloads.

2007-01-08  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageCodecInfo.cs: Remove MonoTODO on SignaturePatterns.

2006-11-22  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageAttributes.cs: Better MonoTODO description.
	* ImageCodecInfo.cs: Add MonoTODO description.
	* Metafile.cs: Use a single MonoTODO on the class itself. MoMA will 
	detect and report that every ctors/methods/properties are throwing  
	NotImplementedException.
	* MetafileHeader.cs: Use a single MonoTODO on the class itself. MoMA 
	will detect and report that every ctors/methods/properties are 
	throwing NotImplementedException.

2006-10-31  Sebastien Pouliot  <sebastien@ximian.com>

	* MetaHeader.cs: Fix layout (order is important in sequential structs)
	and use the struct field names;
	* WmfPlaceableFileHeader.cs: Implement all TODO.

2006-09-14  Sebastien Pouliot  <sebastien@ximian.com>

	* BitmapData.cs: Change fields visibility to private as they either
	have get/set properties or shouldn't be used in managed code (as they
	do not exists when using MS GDI+). Added more warnings comments.

2006-09-01  Sebastien Pouliot  <sebastien@ximian.com>

	* BitmapData.cs: Invert left and top fields to be in sync with gdip.h

2006-08-25  Sebastien Pouliot  <sebastien@ximian.com>

	* ColorMatrix.cs: Add Alloc and Free method helpers for interop.
	* ImageAttributes.cs: Fix all methods accepting a ColorMatrix (i.e.
	which calls GdipSetImageAttributesColorMatrix) to use IntPtr instead
	of the ColorMatrix itself.

2006-07-19  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageFormat.cs: Re-fixed ToString method to match MS output when
	the ImageFormat instance comes from the static properties. Create the
	default ImageFormat on demand (and avoid creating 10 instances of 
	ImageFormat in the static ctor).

2006-05-30  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageFormat.cs: Avoid double-cast in Equals method.

2006-05-24  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageFormat.cs: Fixed ToString method to match MS output.

2006-05-21  Sebastien Pouliot  <sebastien@ximian.com>

	* ColorAdjustType.cs: Removed [Serializable] from 2.0 profile.
	* ColorChannelFlag.cs: Removed [Serializable] from 2.0 profile.
	* ColorMapType.cs: Removed [Serializable] from 2.0 profile.
	* ColorMatrixFlag.cs: Removed [Serializable] from 2.0 profile.
	* ColorMode.cs: Removed [Serializable] from 2.0 profile.
	* EmfPlusRecordType.cs: Removed [Serializable] from 2.0 profile.
	* EmfType.cs: Removed [Serializable] from 2.0 profile.
	* EncoderParameterValueType.cs: Removed [Serializable] from 2.0 
	profile.
	* EncoderValue.cs: Removed [Serializable] from 2.0 profile.
	* ImageCodecFlags.cs: Removed [Serializable] from 2.0 profile.
	* ImageCodecInfo.cs: Removed [Serializable] from 2.0 profile.
	* ImageFlags.cs: Removed [Serializable] from 2.0 profile.
	* ImageLockMode.cs: Removed [Serializable] from 2.0 profile.
	* Metafile.cs: Removed [Serializable] from 2.0 profile.
	* MetafileFrameUnit.cs: Removed [Serializable] from 2.0 profile.
	* MetafileType.cs: Removed [Serializable] from 2.0 profile.
	* PixelFormat.cs: Removed [Serializable] from 2.0 profile.
	* PlayRecordCallback.cs: Removed [Serializable] from 2.0 profile.

2006-05-05  Sebastien Pouliot  <sebastien@ximian.com>

	* PaletteFlags.cs: corcompare fixes for 2.0. Add [Flags] and remove
	[Serializable]

2006-04-20  Peter Dennis Bartok  <pbartok@novell.com>

	* BitmapData.cs: Updated to match the BitmapData structure
	  from libgdiplus r59689.

2006-04-19  Peter Dennis Bartok  <pbartok@novell.com>

	* BitmapData.cs: Updated to match the BitmapData structure
	  from libgdiplus r59661.

2006-04-03 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ImageAttributes.cs: SetColorKey(color, color) now calls the
	color,color,ColorAdjustType.

2006-02-09  Peter Dennis Bartok  <pbartok@novell.com>

	* ColorPalette.cs, EncoderParameters.cs, EncoderParameter.cs,
	  ImageAttributes.cs: 64bit cleanup and some simplifications

2006-01-27  Sebastien Pouliot  <sebastien@ximian.com>

	* ImageAttributes.cs: Ensure Marshal.FreeHGlobal is called for all 
	unmanaged memory allocated with AllocHGlobal.
	* ImageCodecInfo.cs: Ensure Marshal.FreeHGlobal is called for all 
	unmanaged memory allocated with AllocHGlobal.

2005-11-23 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodec.jvm.cs: fixed ProcessOneCodec, sometime it was failed
	on parsing version of codec

2005-11-17 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodec.jvm.cs: fixed WriteImage, removed flush 
	of native output

2005-11-17  Raja R Harinath  <rharinath@novell.com>

	* ColorMatrix.cs: Make it have Sequential layout.

2005-11-16 Konstantin Triger <kostat@mainsoft.com>

        * ImageCodec.jvm.cs: refactoring.

2005-11-14 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodec.jvm.cs: Fixed error handling in codecs emumeration flow

2005-11-13  Kornél Pál  <kornelpal@hotmail.com>

	* ImageFormat.cs: Fixed ToString to use this.Equals to reflect argument
	  changes to ImageFormat objects. Added Exif and Icon strings to ToString
	  and reordered formats to match declaration.

2005-11-13 Konstantin Triger <kostat@mainsoft.com>

        * ImageCodec.jvm.cs: throw an exception if codec is not found.

2005-10-31  Jordi Mas i Hernandez <jordi@ximian.com>

	* ImageFormat.cs: Fixes ToString method

2005-09-27 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodec.jvm.cs: implemented IDsposable, 
	fixed NativeReader, NativeWriter, NativeStream

2005-10-20 Konstantin Triger <kostat@mainsoft.com>

        * Metafile.jvm.cs: implement abstact Clone

2005-10-04 Peter Dennis Bartok <pbartok@novell.com>

	* EncoderParameter.cs, EncoderParameters.cs: Calling GC.SuppressFinalize
	  from the Dispose method; fixes bug #76329

2005-09-21 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodec.jvm.cs: refactoring of read/write methods, members access levels

2005-09-14 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodecInfo.jvm.cs: fixed ImageCodec namespace
	* ImageCodec.jvm.cs: refactoring of read/write methods

2005-09-07 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodecInfo.jvm.cs: fixed GetValueFromMetadata, SetResolution

2005-09-07 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodecInfo.jvm.cs: Refactoring
	* Added ImageCodec.jvm.cs

2005-08-28 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ImageCodecInfo.jvm.cs: Fixed Iterate

2005-08-03 Andrew Skiba <andrews@mainsoft.com>

	* ImageCodecInfo.jvm.cs: implement via java imageio, add internal APIs for
	fast read-only requests
	* Methafile.jvm.cs: change in not implemented api to match image.jvm.cs

2005-08-03 Andrew Skiba <andrews@mainsoft.com>

	* Metafile.jvm.cs: add TARGET_JVM implementation

2005-08-03 Andrew Skiba <andrews@mainsoft.com>

	* ColorPalette.cs, FrameDimension.cs, EncoderParameters.cs: TARGET_JVM
	exclude not supported internal methods
	* EncoderParameter.jvm.cs, ImageAttributes.jvm.cs, ImageFormat.jvm.cs,
	ImageCodecInfo.jvm.cs: added TARGET_JVM implementation of these classes

2005-03-23 Jordi Mas i Hernandez <jordi@ximian.com>

	* ColorPalette.cs: fixes ColorPalette marshaling	

2004-03-21 Jordi Mas i Hernadez <jordi@ximian.com>

	* ColorMatrix.cs: fixes Matrix00 init 
	* ImageAttributes.cs: fixes dispose method and signature

2004-02-25 Jordi Mas i Hernadez <jordi@ximian.com>

	* ColorMatrix.cs: rewritten to be able to marshall it properly
	
2004-12-27  Zoltan Varga  <vargaz@freemail.hu>

	* ImageCodecInfo.cs: Fix marshalling of arrays on amd64.

2004-11-25  Marek Safar  <marek.safar@seznam.cz>

	* ColorPalette.cs: Add CheckStatus to GetAdjustedPalette.

2004-11-03  Miguel de Icaza  <miguel@ximian.com>

	* ColorPalette.cs: Add internal Clone method

2004-10-08  Ravindra  <rkumar@novell.com>

	* BitmapData.cs: Synchronized the class with BitmapData struct
	in libgdiplus.

2004-06-13  Gert Driesen <drieseng@users.sourceforge.net>
	
	* EmfPlusRecordType.cs: fixed mismatches in enum field values

2004-05-18 Jordi Mas i Hernadez <jordi@ximian.com>
	* ImageAttributes.cs: SetBrushRemapTable and SetRemapTable were
	passing bad parameters to GDI+ causing them not to work 

2004-05-16  Gert Driesen (drieseng@users.sourceforge.net)

	* EncoderParameterValueType.cs: fix Windows build (CSC), 
	MCS bug #58571

	* EncoderParameter.cs: removed ctors taking int value,
        to fix public API

2004-05-14  Vladimir Vukicevic  <vladimir@pobox.com>

	* EncoderParameters.cs: Added ToNativePtr() method to marshal
	struct correctly to a native struct.  Resulting data should be
	FreeHGlobal'd when finished.

	* EncoderParameter.cs: Changed data storage to correspond to
	native code layout (so we can pass these structs directly to
	native code).  Also changed layout to match native layout.

	* EncoderParameterValueType.cs: force EncoderParameterValueType to
	be Int32

2004-05-13 Jordi Mas i Hernadez <jordi@ximian.com>

	* ColorMatrix.cs:Make private data private 
	* ColorPalette.cs: Make private data private
	* Encoder.cs: Make private data private
	* EncoderParameter.cs: Make private data private
	* EncoderParameters.cs: Make private data private
	* MetaHeader.cs: Make private data private
	* PropertyItem.cs: Make private data private

2004-05-04  Vladimir Vukicevic  <vladimir@pobox.com>

	* BitmapData.cs: re-synchronized with libgdiplus; also
	removed memory deallocs here (as the data is always owned
	by libgdiplus)

2004-04-28 Sanjay Gupta <gsanjay@novell.com>
	
	Modified files from dos2unix format.

2004-04-27 Ravindra <rkumar@novell.com>

	* ImageAttributes.cs: Implemented SetWrapMode(WrapMode) method.

2004-04-27 Jordi Mas i Hernadez <jordi@ximian.com>

	* ImageFormat.cs: completed missimg members
	* ImageCodecInfo.cs: Use GDI+ calls instead of native C#

2004-04-27 Sanjay Gupta <gsanjay@novell.com>
	* ImageFormat.cs: Implemented Equals() method.

2004-04-27 Sanjay Gupta <gsanjay@novell.com>
	* ImageFormat.cs: Implemented ToString() method.

2004-04-06  Vladimir Vukicevic  <vladimir@pobox.com>

	* BitmapData.cs: synced up data structure with libgdiplus

	* BmpCodec.cs, JPEGCodec.cs, PNGCodec.cs: Removed codec impls,
	left just codecinfo getters; the codecs are in libgdiplus

	* ImageCodecInfo.cs: removed encode/decode delegates
	
2004-03-31 Jordi Mas i Hernadez <jordi@ximian.com>
	* FrameDimension.cs: added missing members 
	
2004-03-26 Jordi Mas i Hernadez <jordi@ximian.com>
	* ImageAttributes.cs: added missing members and complete the wrapper	

2004-03-04 Jordi Mas i Hernadez <jordi@ximian.com>
	* BmpCodec.cs: fixes DPI in BMP
	* Image.cs: gets DPI using GDI+ api

2004-03-04 Jordi Mas i Hernadez <jordi@ximian.com>
	* BmpCodec.cs
		Added support for diffent formats
		Fixed bugs in import and export
		Support for OS/2 and palettes
	* Image.cs
		Palettes	

2004-03-04 Sanjay Gupta <gsanjay@novell.com>
	* Metafile.cs: Added constructor with correct signature.

2004-03-04 Nick Drochak <ndrochak@ieee.org>

	* Metafile.cs: Fix build, remove duplicate member.

2004-03-03 Sanjay Gupta <gsanjay@novell.com>
	*ImageAttributes.cs: Added few missing functions
	*Metafile.cs: Added stubs for missing constructors and functions

2004-03-03 Nick Drochak <ndrochak@ieee.org>

	* BmpCodec.cs: Remove unsed variable.

2004-02-17 Ravindra <rkumar@novell.com>
	* EncoderParameter.cs: Did few bug fixes and changed the file
	format to unix.

2004-02-13 Sanjay Gupta <gsanjay@novell.com>
	* FrameDimension.cs: Implemented missing functionalities

2004-02-12 Ravindra <rkumar@novell.com>
	* EncoderParameters.cs: Implemented.
	* EncoderParameter.cs: Implemented.

2004-01-21 Jordi Mas i Hernàdez <jmas@softcatala.org>
	* BmpBitmap.cs: fixed encoding and decoding problems
	* ImageAttributes.cs: implemented

2004-01-19  Ravindra <rkumar@novell.com>

	* Encoder.cs: Implemented.

2004-01-10  Ravindra <rkumar@novell.com>

	* All Enums: Made serializable.

	* ImageAttributes.cs: Implements ICloneable.

	* Metafile.cs: Made serializable and invisible to COM.

2003-11-13  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* ColorMap.cs: Implemented
	* ColorMatrix.cs: Implemented, Removed unneccesary members
	* ImageAttributes.cs: Fixed signature
	* ImageCodecInfo.cs: Added missing attribure, hide constructor
	* ImageFormat.cs: Implemented, Added attribute
	* MetaHeader.cs: Implemented
	* PropertyItem.cs: Implemented
	* ImageFlags.cs: Added Attribute
	* ImageCodecFlags.cs: Added Attribute
	* EmfPlusRecordType.cs: Added missing members

2003-11-12  Alexandre Pigolkine <pigolkine@gmx.de>
	* BitmapData.cs		new function to convert BRG to RGB
	* JPEGCodec.cs		convert BRG to RBG
	* PNGCodec.cs
					
					
2003-11-02  Alexandre Pigolkine <pigolkine@gmx.de>
	* BmpCodec.cs
	* ImageCodecInfo.cs
	* JPEGCodec.cs
	* PNGCodec.cs
					codec can select pixel format of bitmap 
	
2003-10-23  Miguel de Icaza  <miguel@ximian.com>

	* JPEGCodec.cs (JSAMPARRAY): Do not allocate memory here anymore,
	we will just have the JPEG library copy directly into our buffer. 

	(Encode, Decode): Ported to the new model which avoid copies, and
	eliminates InternalImageInfo.

	TODO: need to port the PNG coder/decoder, and add support for RGBA
	images which got dropped from this version

	* BmpCodec.cs: Rework this one to use BitmapData and Image.  Do
	not use the RawBytes property, instead pull the data one line at a
	time, and write that out.

	* ImageCodecInfo.cs: Make the encoding and decoding delegates take
	a Image parameter;  
	
	* BmpCodec.cs: 

	* BitmapData.cs: Make this one sequential, and also mimic the
	layout of GdiPlus.h so we can use this instead of making copies
	back and forth.

2003-10-12 Alexandre Pigolkine
	* BmpCodec.cs		warning removed

2003-07-23 Alexandre Pigolkine
	* JPEGCodec.cs
	* PNGCodec.cs		
	* BmpCodec.cs		cosmetic changes

2003-07-22 Alexandre Pigolkine
	* ImageCodecInfo.cs
	* ImageFormat.cs
	* JPEGCodec.cs
		changes for PNG codec
		
	* PNGCodec.cs		added
	
2003-07-21  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* Metafile.cs: Inherits from image (fix for System.Drawing.Design)

2003-06-29 Alexandre Pigolkine
	* BmpCodec.cs		handle 32bpp images
	* JPEGCodec.cs		small fix

2003-06-27 Alexandre Pigolkine <pigolkine@gmx.de>
	* JPEGCodec.cs 	encode 32 bpp images

2003-06-23 Alexandre Pigolkine <pigolkine@gmx.de>
	* JPEGCodec.cs 	set pixel format in InternalImageInfo
	
2003-06-23 Alexandre Pigolkine <pigolkine@gmx.de>
	* BmpCodec.cs 	pixel format check added
	* JPEGCodec.cs  encoder implemented

2003-06-15 Alexandre Pigolkine <pigolkine@gmx.de>
	* ColorPalette.cs
	* ImageCodecInfo.cs
	* ImageFormat.cs
		implementation added
		
	* BmpCodec.cs
	* JPEGCodec.cs
		added	
	
2002-9-2  DennisHayes <dennish@raytek.com>

* PropertyItem.cs t
* MetaHeader.cs t
* MetafileHeader.cs t
* Metafile.cs t
* ImageFormat.cs t
* ImageCodecInfo.cs t
* ColorMatrix.cs t
* ColorMap.cs t
* WmfPlaceableFileHeader.cs t
* Added todos back

2002-9-2  DennisHayes <dennish@raytek.com>
	* checked in for Everaldo Canuto (everaldo.canuto@bol,com.br)
	* BitmapData.cs
	* ColorAdjustType.cs
	* ColorChannelFlag.cs
	* ColorMap.cs
	* ColorMapType.cs
	* ColorMatrix.cs
	* ColorMatrixFlag.cs
	* ColorMode.cs
	* EmfPlusRecordType.cs
	* EmfType.cs
	* EncoderParameterValueType.cs
	* EncoderValue.cs
	* ImageCodecFlags.cs
	* ImageCodecInfo.cs
	* ImageFlags.cs
	* ImageFormat.cs
	* ImageLockMode.cs
	* MetafileFrameUnit.cs
	* MetafileHeader.cs
	* MetaHeader.cs
	* PaletteFlags.cs
	* PixelFormat.cs
	* PlayRecordCallback.cs
	* PropertyItem.cs
	* WmfPlaceableFileHeader.cs
	* Added null classes for most/all classes, Many stubs, and some implmentation

2002-9-2  DennisHayes <dennish@raytek.com>

	* ColorPalette.cs
	* FrameDimension.cs
	* Metafile.cs
	* Added stubs, implmentation

2002-05-03  Mike Kestner  <mkestner@speakeasy.net>

	* Metafile.cs : Use System.IO. Fix exception typos.

2002-04-27  Christian Meyer  <Christian.Meyer@cs.tum.edu>

	* Metafile.cs: Copyright now holds Ximian.

2002-04-21  Dennis Hayes <dennish@raytek.com>

	* corrected emum values.

2002-04-14  Christian Meyer  <Christian.Meyer@cs.tum.edu>

	* ChangeLog: created.
	* Metafile.cs: Added. Wrote some ctors. No impl done, yet.

